#include "Menu.h"

sensor::sensor(QWidget* parent,const char* name):QLineEdit(parent,name)
{
  tosend=(menu *)parent;
  setFocusPolicy(QWidget::ClickFocus);
}

void sensor::keyPressEvent(QKeyEvent *event)
{
  QString tmp;
  char *bf;

  shc=event->key();
  mod=event->state();
  tmp=QString(" ");

  switch(mod)
    {
    case ShiftButton:
      tmp+=QString("SHIFT+");
      break;
    case ControlButton:
      tmp+=QString("CTRL+");
      break;
    case AltButton:
      tmp+=QString("ALT+");
      break;
    }
  bf=(char *)malloc(5*sizeof(char));
  sprintf(bf,"%c",shc);
  tmp+=QString(bf);
  setText(tmp.data());
  tosend->refreshIT(who);
}

menu::menu(QWidget* parent,const char* name):QWidget( parent, name, 0 )
{
  QButtonGroup *bg1;
  bg1 = new QButtonGroup( this, "bg1" );
  bg1->setGeometry( 10, 10, 380, 280 );
  bg1->setFrameStyle( 49 );
  bg1->setAlignment( 1 );
  
  QLabel *l= new QLabel( this, "text" );
  l->setGeometry( 20, 20, 80, 20 );
  l->setText( "label" );
  l->setAlignment( 290 );
  l->setMargin( -1 );

  label=new QLineEdit( this, "text" );
  label->setGeometry( 120, 20, 100, 20 );
  label->setFrame( TRUE );
  label->setMaxLength(29);
  
  hp=new QCheckBox("help menu",this,"hp");
  hp->setGeometry(240,20,80,20);

  l=new QLabel( this, "shc" );
  l->setGeometry( 20, 50, 80, 20 );
  l->setText( "shortcut" );
  l->setAlignment( 290 );
  l->setMargin( -1 );

  mySensor=new sensor(this,"shc");
  mySensor->setGeometry( 120, 50, 100, 20);
  mySensor->setWho(-1);
  
  QButtonGroup *bg2;
  bg2 = new QButtonGroup( this, "bg1" );
  bg2->setGeometry( 20, 80, 360, 200 );
  bg2->setFrameStyle( 49 );
  bg2->setAlignment( 1 );
  bg2->setTitle("Items");

  item = new QLineEdit( this, "item" );
  item->setGeometry(30,100,140,20);
  item->setFrame( TRUE );
  item->setMaxLength(29);
  connect(item,SIGNAL(returnPressed()),SLOT(addItem()));

  QPushButton *addItm=new QPushButton("item",this,"add");
  addItm->setGeometry(180,100,50,20);
  connect(addItm,SIGNAL(clicked()),SLOT(addItem()));

  QPushButton *addSbm=new QPushButton("menu",this,"menu");
  addSbm->setGeometry(235,100,60,20);
  connect(addSbm,SIGNAL(clicked()),SLOT(addSub()));

  QPushButton *addSpr=new QPushButton("separator",this,"spr");
  addSpr->setGeometry(300,100,60,20);
  connect(addSpr,SIGNAL(clicked()),SLOT(addSep()));

  list=new QListBox(this,"list");
  list->setGeometry(30,120,140,100);
  connect(list,SIGNAL(highlighted(int)),SLOT(setIT(int)));

  comment=new QLabel(this, "comment");
  comment->setGeometry(180,120,180,20);
  comment->setAlignment(AlignCenter);
  comment->setText("adding to main menu");

  QPushButton *rm=new QPushButton("remove",this,"rm");
  rm->setGeometry(180,160,80,20);
  connect(rm,SIGNAL(clicked()),SLOT(rmIT()));

  shcLabel=new QLabel(this,"label");
  shcLabel->setGeometry(40,230,120,20);
  shcLabel->setText("item shortcut");
  shcLabel->setEnabled(FALSE);

  itemSensor=new sensor(this,"iShc");
  itemSensor->setGeometry(180,230,80,20);
  itemSensor->setEnabled(FALSE);

  clear=new QPushButton("clear",this,"clr");
  clear->setGeometry(270,230,40,20);
  connect(clear,SIGNAL(clicked()),SLOT(clrIT()));
  clear->setEnabled(FALSE);

  cb=new QCheckBox("checkbox item",this,"clr");
  cb->setGeometry(40,250,120,20);
  connect(cb,SIGNAL(clicked()),SLOT(check()));
  cb->setEnabled(FALSE);

  st=new QCheckBox("on",this,"clr");
  st->setGeometry(180,250,40,20);
  connect(st,SIGNAL(clicked()),SLOT(state()));
  st->setEnabled(FALSE);

  resize( 400,300 );
}

void menu::setShc(int shc,int mod,QString shcString)
{
  shortcut=shc;
  modifier=mod;
  keys=shcString;
  mySensor->setText(keys.data());
}

void menu::clrIT()
{
  int i,num;

  list->clearSelection();
  itemSensor->setText("");
  (items.current())->setKeys(QString(""));  
}

void menu::setIT(int val)
{
  int i,j;
  MyMenuItem *it;
  QString tmp,tmp1;

  tmp=QString(list->text(val)); //check submenu
  tmp1=tmp.stripWhiteSpace();
  sub=tmp.length()-tmp1.length();

  it=items.at(val);
  if((!it->separator)&&(!it->isMenu()))
    {
      shcLabel->setEnabled(TRUE);
      itemSensor->setEnabled(TRUE);
      clear->setEnabled(TRUE);
      cb->setEnabled(TRUE);
      cb->setChecked(it->isCB());

      if(cb->isChecked())
	{
	  st->setEnabled(TRUE);
	  st->setChecked(it->getState());
	}
      else
	{
	  st->setEnabled(FALSE);
	  st->setChecked(FALSE); 
	}

      if(it->getKeys()!=NULL)
	itemSensor->setText((it->getKeys()).data());
      else
	itemSensor->setText("");

      itemSensor->setFocus();
      if(sub==0)
	comment->setText("adding to main menu");
    }

  if(it->separator)
    {
      shcLabel->setEnabled(FALSE);
      itemSensor->setEnabled(FALSE);
      clear->setEnabled(FALSE);
      cb->setEnabled(FALSE);
      cb->setChecked(FALSE);
      st->setEnabled(FALSE);
      st->setChecked(FALSE);
      itemSensor->setText("");
    }

  if(it->isMenu())
    {
      shcLabel->setEnabled(TRUE);
      itemSensor->setEnabled(TRUE);
      clear->setEnabled(TRUE);
      cb->setEnabled(FALSE);
      cb->setChecked(FALSE);
      st->setEnabled(FALSE);
      st->setChecked(FALSE);

      if(it->getKeys()!=NULL)
	itemSensor->setText((it->getKeys()).data());
      else
	itemSensor->setText("");

      itemSensor->setFocus();
      sub++;
      QString nothing("adding to ");
      nothing+=tmp1;
      comment->setText(nothing.data());
    }      
  itemSensor->setWho(val);
}

void menu::addItem()  //add "normal item"
{
  int i,j,place;
  QString tmp=QString(item->text());
  QString tmp1;

  if(tmp.length()>0)
    {
      MyMenuItem *it;
      QString tmp1=QString("");

      for(i=0;i<sub;i++)
	tmp1+=" ";

      if(list->currentItem()==-1)
	place=-1;
      else
	for(i=list->currentItem()+1;i<list->count()+1;i++)

	  if(QString(list->text(i)).left(sub)!=tmp1)
	    {
	      place=i;
	      break;
	    }

      tmp1+=tmp.stripWhiteSpace();

      if(place<0)
	{
	  list->insertItem(tmp1.data());
	  it=new MyMenuItem(tmp1,0);      
	  items.append(it);
	}
      else
	{
	  list->insertItem(tmp1.data(),place);
	  it=new MyMenuItem(tmp1,0);      
	  items.insert(place,it);
	}
    }
}

void menu::addSub()  //add another menu as submenu
{  
  int i,j,place;
  QString tmp=QString(item->text());

  if(tmp.length()>0)
    {
      MyMenuItem *it;
      QString tmp1=QString("");

      for(i=0;i<sub;i++)
	tmp1+=" ";

      if(list->currentItem()==-1)
	place=-1;
      else
	for(i=list->currentItem()+1;i<list->count()+1;i++)

	  if(QString(list->text(i)).left(sub)!=tmp1)
	    {
	      place=i;
	      break;
	    }

      tmp1+=tmp.stripWhiteSpace();
      if(place<0)
	{
	  list->insertItem(tmp1.data());
	  it=new MyMenuItem(tmp1,1);      
	  items.append(it);
	}
      else
	{
	  list->insertItem(tmp1.data(),place);
	  it=new MyMenuItem(tmp1,1);      
	  items.insert(place,it);
	}
    }
}

void menu::addSep() //add separator
{   
  MyMenuItem *it;
  int i,j,place;
  QString tmp1=QString("");

  for(i=0;i<sub;i++)
    tmp1+=" ";

  if(list->currentItem()==-1)
    place=-1;
  else
    for(i=list->currentItem()+1;i<list->count()+1;i++)
      if(QString(list->text(i)).left(sub)!=tmp1)
	{
	  place=i;
	  break;
	}

  tmp1+=QString("------------------");

  if(place<0)
    {
      list->insertItem(tmp1.data());
      it=new MyMenuItem("",2);      
      items.append(it);
    }
  else
    {
      list->insertItem(tmp1.data(),place);
      it=new MyMenuItem("",2);      
      items.insert(place,it);
    }
}

void menu::rmIT()  //remove current item
{
  MyMenuItem *tmp;
  int i;

  if(((i=list->currentItem())!=-1)&&(list->count()!=0))
    {
      list->removeItem(i);
      tmp=items.at(i);
      items.remove(tmp);
    }

  if(list->count()==0)
    {
      shcLabel->setEnabled(FALSE);
      itemSensor->setEnabled(FALSE);
      clear->setEnabled(FALSE);
    }
}

void menu::refreshIT(int val)
{

  if(val>=0)
    {
      (items.current())->setShc(itemSensor->getSHC());
      (items.current())->setMod(itemSensor->getMOD());
      (items.current())->setKeys(QString(itemSensor->text()));
    }
  else
    {
      shortcut=mySensor->getSHC();
      modifier=mySensor->getMOD();
      keys=QString(mySensor->text());
    }
}

void menu::check()
{
  st->setEnabled(cb->isChecked());
  (items.current())->setCB(cb->isChecked());
}

void menu::state()
{
  (items.current())->setState(st->isChecked());  
}

void menu::addMenuItem(MyMenuItem *val)  //for adding from outside
{
  items.append(val);

  if(!val->separator)
    list->insertItem((val->getLabel()).data());
  else
    list->insertItem("------------------");
}

menu::~menu()
{
}





















